﻿namespace StructPartialInitialization {

	struct S {
		public int A;
		public int B;
	}

	class Program {
		static void Main(string[] args) {
			S s1;

			// Error: Use of possibly unassigned field 'A'
			// Error: Use of possibly unassigned field 'B'
			// Console.WriteLine($"{s1.A}, {s1.B}");

			s1 = new S();
			Console.WriteLine($"{s1.A}, {s1.B}");

			int i = new int();
			Console.WriteLine($"i: {i}");

			S s2 = s1;
			Console.WriteLine($"{s2.A}, {s2.B}");

			S s3;
			s3.B = 5;
			// Error: Use of possibly unassigned field 'A'
			// Console.WriteLine($"{s3.A}, {s3.B}");
			Console.WriteLine($"?, {s3.B}");

			S s4;
			// Error: Use of unassigned local variable 's3'
			// s4 = s3;

			s3.A = 8;
			Console.WriteLine($"{s3.A}, {s3.B}");

			s4 = s3;
			Console.WriteLine($"{s4.A}, {s4.B}");
		}
	}


}
